var Seed = require('seed')
  , connect = require('connect');

var SiteSchema = new Seed.Schema({
  name: {
    type: String,
    required: true
  },
  domain: {
    type: String,
    required: true,
    unique: true
  },
  path: {
    type: String,
    required: true
  },
  port: {
    type: Number,
    required: true
  }
});

var Site = Seed.Model.extend('site', {
  schema: SiteSchema,
  
  initialize: function () {
    var self = this;
    
    this.server = connect.createServer();
    this.server.use(connect.static(this.get('path')));
    
  },
  
  listen: function () {
    var port = this.get('port');
    this.server.listen(port);
    this.emit('listening', port);
  }
});

module.exports = Site;